diff -rNci gcc-2.7.2/reload1.c gcc-2.7.2p/reload1.c
*** gcc-2.7.2/reload1.c	Sun Nov  5 16:22:22 1995
--- gcc-2.7.2p/reload1.c	Tue Jan 23 09:25:31 1996
***************
*** 7173,7176 ****
--- 7389,7643 ----
  	}
      }
    return count;
+ }
+ 
+ /* intel1 */
+ 
+ /* return 1 if rx is a stack slot */
+ int
+ is_a_stack_slot (rx)
+   rtx rx;
+ {
+  if (GET_CODE (rx) != MEM)
+     {
+       return (0);
+     }
+   if (GET_CODE (XEXP (rx, 0)) == PLUS 
+       && XEXP ( XEXP (rx, 0), 0) == stack_pointer_rtx 
+       && !frame_pointer_needed)
+     {
+       if ( GET_CODE (XEXP ( XEXP (rx, 0), 1)) == CONST_INT)
+         {
+           return (1);
+         }
+       else
+         {
+           return (0);
+         }
+     }
+   else if (GET_CODE (XEXP (rx, 0)) == PLUS 
+       && XEXP ( XEXP (rx, 0), 0) == frame_pointer_rtx
+       && frame_pointer_needed)
+     {
+       if ( GET_CODE (XEXP ( XEXP (rx, 0), 1)) == CONST_INT)
+         {
+           return (1);
+         }
+       else
+         {
+           return (0);
+         }
+     }
+   else if ((XEXP (rx, 0) == frame_pointer_rtx  && frame_pointer_needed)
+            || (XEXP (rx, 0) == stack_pointer_rtx && ! frame_pointer_needed))
+     {
+       return (1);
+     }
+   else
+     {
+       return (0);
+     }
+    
+ }
+ 
+ /*
+   if rx is a reload slot then set *indx to the index in the
+     reload_slots array which contains it and return 1
+   else
+     return 0
+ */
+ 
+ int
+ is_a_reload_stack_slot (rx, indx, cur_stack_offset, reload_insn)
+      rtx rx;
+      int *indx;
+      int cur_stack_offset;
+      rtx reload_insn;
+ {
+   int i, is_based_on_stack_pointer, stack_offset, stack_i_offset;
+   rtx stack_slot_i;
+ 
+   
+   if (GET_CODE (rx) == REG && REGNO (rx) >= FIRST_PSEUDO_REGISTER
+       && pseudo_spilled[REGNO (rx)])
+     {
+       *indx = -1;
+       return (1);
+     }
+   if (GET_CODE (rx) == SUBREG 
+       && GET_CODE (SUBREG_REG (rx)) == MEM)
+     {
+       return (is_a_reload_stack_slot (SUBREG_REG (rx), indx, 
+                                       cur_stack_offset, reload_insn));
+     }
+   if (GET_CODE (rx) != MEM)
+     {
+       return (0);
+     }
+   is_based_on_stack_pointer = 0;
+   if (GET_CODE (XEXP (rx, 0)) == PLUS 
+       && XEXP ( XEXP (rx, 0), 0) == stack_pointer_rtx 
+       && !frame_pointer_needed)
+     {
+       is_based_on_stack_pointer = 1;
+       if ( GET_CODE (XEXP ( XEXP (rx, 0), 1)) == CONST_INT)
+         {
+           stack_offset = XINT (XEXP ( XEXP (rx, 0), 1), 0);
+         }
+       else
+         {
+           return (0);
+         }
+     }
+   else if (GET_CODE (XEXP (rx, 0)) == PLUS 
+       && XEXP ( XEXP (rx, 0), 0) == frame_pointer_rtx
+       && frame_pointer_needed)
+     {
+       if ( GET_CODE (XEXP ( XEXP (rx, 0), 1)) == CONST_INT)
+         {
+           ;
+         }
+       else
+         {
+           return (0);
+         }
+     }
+   else if ((XEXP (rx, 0) == frame_pointer_rtx  && frame_pointer_needed)
+            || (XEXP (rx, 0) == stack_pointer_rtx && ! frame_pointer_needed))
+     {
+       is_based_on_stack_pointer = (XEXP (rx, 0) == stack_pointer_rtx );
+     }
+   else
+     {
+       return (0);
+     }
+            
+ 
+   for (i = 0; i < num_reload_stack_slots; i++)
+     {
+       if (!is_based_on_stack_pointer)
+         {
+           if ((reload_insn == NULL || reload_insn == reload_slots[i].reload_insn)
+               && rtx_equal_p (XEXP (reload_slots[i].reload_stack_slot, 0), 
+                            XEXP (rx, 0)))
+ 	    {
+ 	      *indx = i;
+ 	      return (1);
+ 	    }
+ 	}
+       else
+         {
+           stack_slot_i = XEXP (reload_slots[i].reload_stack_slot, 0);
+           if (GET_CODE (stack_slot_i) == PLUS 
+               && XEXP ( stack_slot_i, 0) == stack_pointer_rtx)
+             {
+               if ( GET_CODE (XEXP ( stack_slot_i, 1)) == CONST_INT)
+                 {
+                   stack_i_offset = XINT (XEXP ( stack_slot_i, 1), 0);
+                 }
+               else
+                 {
+                   abort ();
+                 }
+             }
+           else if (stack_slot_i == stack_pointer_rtx)
+             {
+               stack_i_offset = 0;
+             }
+           else
+             {
+               abort ();
+             }
+           stack_i_offset -= reload_slots[i].cur_stack_offset;
+           if ((reload_insn == NULL || reload_insn == reload_slots[i].reload_insn)
+               && (stack_offset - cur_stack_offset == stack_i_offset))
+             {
+ 	      *indx = i;
+ 	      return (1);
+             }
+         }
+     }
+   return (0);
+ }
+ 
+ 
+ int
+ are_same_reload_slots (slot1, offset1, slot2, offset2)
+   rtx slot1, slot2;
+   int offset1, offset2;
+ {
+   rtx base_reg1, base_reg2;
+   int add_val1, add_val2;
+ 
+   if (GET_CODE (XEXP (slot1, 0)) == PLUS)
+     {
+       if (GET_CODE (XEXP (XEXP (slot1, 0), 0)) == REG)
+         {
+           base_reg1 = XEXP (XEXP (slot1, 0), 0);
+           if (GET_CODE (XEXP (XEXP (slot1, 0), 1)) == CONST_INT)
+             {
+               add_val1 = XINT (XEXP (XEXP (slot1, 0), 1), 0);
+             }
+         }
+     }
+   else
+     {
+       add_val1 = 0;
+       base_reg1 = XEXP (slot1, 0);
+     }
+     
+   if (GET_CODE (XEXP (slot2, 0)) == PLUS)
+     {
+       if (GET_CODE (XEXP (XEXP (slot2, 0), 0)) == REG)
+         {
+           base_reg2 = XEXP (XEXP (slot2, 0), 0);
+           if (GET_CODE (XEXP (XEXP (slot2, 0), 1)) == CONST_INT)
+             {
+               add_val2 = XINT (XEXP (XEXP (slot2, 0), 1), 0);
+             }
+         }
+     }
+   else
+     {
+       add_val2 = 0;
+       base_reg2 = XEXP (slot2, 0);
+     }
+   if (base_reg1 == frame_pointer_rtx)
+     {
+       offset1 = 0;
+     }
+   if (base_reg2 == frame_pointer_rtx)
+     {
+       offset2 = 0;
+     }
+   if (base_reg1 == base_reg2 
+       && ((add_val1 - offset1) == (add_val2 - offset2)))
+     {
+       return (1);
+     }
+   return (0);
+ }
+ 
+ /*
+   if x refernces a paramater then return 1
+   else return 0
+ */
+ 
+ int 
+ is_a_param_slot (x)
+      rtx x;
+ {
+   if (GET_CODE (x) == MEM && GET_CODE (XEXP (x, 0)) == PLUS
+       && GET_CODE (XEXP (XEXP (x, 0), 0)) == REG
+       && REGNO (XEXP (XEXP (x, 0), 0)) == ARG_POINTER_REGNUM
+       && GET_CODE (XEXP (XEXP (x, 0), 1)) == CONST_INT)
+     {
+       return (1);
+     }
+   if (GET_CODE (x) == MEM && GET_CODE (XEXP (x, 0)) == REG
+       && REGNO (XEXP (x, 0)) == ARG_POINTER_REGNUM)
+     {
+       return (1);
+     }
+   return (0);
  }
diff -rNci gcc-2.7.2/reorg.c gcc-2.7.2p/reorg.c
*** gcc-2.7.2/reorg.c	Fri Sep 15 21:38:55 1995
--- gcc-2.7.2p/reorg.c	Thu Jun 15 12:02:32 1995
***************
*** 2857,2880 ****
  	  && eligible_for_delay (insn, slots_filled, trial, flags)
  	  && no_labels_between_p (insn, trial))
  	{
- 	  rtx *tmp;
  	  slots_filled++;
  	  delay_list = add_to_delay_list (trial, delay_list);
- 
- 	  /* TRIAL may have had its delay slot filled, then unfilled.  When
- 	     the delay slot is unfilled, TRIAL is placed back on the unfilled
- 	     slots obstack.  Unfortunately, it is placed on the end of the
- 	     obstack, not in its original location.  Therefore, we must search
- 	     from entry i + 1 to the end of the unfilled slots obstack to
- 	     try and find TRIAL.  */
- 	  tmp = &unfilled_slots_base[i + 1];
- 	  while (*tmp != trial && tmp != unfilled_slots_next)
- 	    tmp++;
- 
  	  /* Remove the unconditional jump from consideration for delay slot
! 	     filling and unthread it.   */
! 	  if (*tmp == trial)
! 	    *tmp = 0;
  	  {
  	    rtx next = NEXT_INSN (trial);
  	    rtx prev = PREV_INSN (trial);
--- 2857,2868 ----
  	  && eligible_for_delay (insn, slots_filled, trial, flags)
  	  && no_labels_between_p (insn, trial))
  	{
  	  slots_filled++;
  	  delay_list = add_to_delay_list (trial, delay_list);
  	  /* Remove the unconditional jump from consideration for delay slot
! 	     filling and unthread it.  */
! 	  if (unfilled_slots_base[i + 1] == trial)
! 	    unfilled_slots_base[i + 1] = 0;
  	  {
  	    rtx next = NEXT_INSN (trial);
  	    rtx prev = PREV_INSN (trial);
***************
*** 2974,2985 ****
  	 is a CALL_INSN (or a CALL_INSN is passed), cannot trap (because the
  	 call might not return).
  
! 	 There used to be code which continued past the target label if
! 	 we saw all uses of the target label.  This code did not work,
! 	 because it failed to account for some instructions which were
! 	 both annulled and marked as from the target.  This can happen as a
! 	 result of optimize_skip.  Since this code was redundant with
! 	 fill_eager_delay_slots anyways, it was just deleted.  */
  
        if (slots_filled != slots_to_fill
            && (GET_CODE (insn) != JUMP_INSN
--- 2962,2975 ----
  	 is a CALL_INSN (or a CALL_INSN is passed), cannot trap (because the
  	 call might not return).
  
! 	 If this is a conditional jump, see if it merges back to us early
! 	 enough for us to pick up insns from the merge point.  Don't do
! 	 this if there is another branch to our label unless we pass all of
! 	 them.
! 
! 	 Another similar merge is if we jump to the same place that a
! 	 later unconditional jump branches to.  In that case, we don't
! 	 care about the number of uses of our label.  */
  
        if (slots_filled != slots_to_fill
            && (GET_CODE (insn) != JUMP_INSN
***************
*** 2989,2994 ****
--- 2979,2986 ----
  	{
  	  rtx target = 0;
  	  int maybe_never = 0;
+ 	  int passed_label = 0;
+ 	  int target_uses;
  	  struct resources needed_at_jump;
  
  	  CLEAR_RESOURCE (&needed);
***************
*** 3005,3011 ****
  	      mark_set_resources (insn, &set, 0, 1);
  	      mark_referenced_resources (insn, &needed, 1);
  	      if (GET_CODE (insn) == JUMP_INSN)
! 		target = JUMP_LABEL (insn);
  	    }
  
  	  for (trial = next_nonnote_insn (insn); trial; trial = next_trial)
--- 2997,3009 ----
  	      mark_set_resources (insn, &set, 0, 1);
  	      mark_referenced_resources (insn, &needed, 1);
  	      if (GET_CODE (insn) == JUMP_INSN)
! 		{
! 		  /* Get our target and show how many more uses we want to
! 		     see before we hit the label.  */
! 		  target = JUMP_LABEL (insn);
! 		  target_uses = LABEL_NUSES (target) - 1;
! 		}
! 		
  	    }
  
  	  for (trial = next_nonnote_insn (insn); trial; trial = next_trial)
***************
*** 3014,3021 ****
  
  	      next_trial = next_nonnote_insn (trial);
  
! 	      if (GET_CODE (trial) == CODE_LABEL
! 		  || GET_CODE (trial) == BARRIER)
  		break;
  
  	      /* We must have an INSN, JUMP_INSN, or CALL_INSN.  */
--- 3012,3033 ----
  
  	      next_trial = next_nonnote_insn (trial);
  
! 	      if (GET_CODE (trial) == CODE_LABEL)
! 		{
! 		  passed_label = 1;
! 
! 		  /* If this is our target, see if we have seen all its uses.
! 		     If so, indicate we have passed our target and ignore it.
! 		     All other labels cause us to stop our search.  */
! 		  if (trial == target && target_uses == 0)
! 		    {
! 		      target = 0;
! 		      continue;
! 		    }
! 		  else
! 		    break;
! 		}
! 	      else if (GET_CODE (trial) == BARRIER)
  		break;
  
  	      /* We must have an INSN, JUMP_INSN, or CALL_INSN.  */
***************
*** 3040,3046 ****
  		{
  		  if (target == 0)
  		    break;
! 		  else if (JUMP_LABEL (trial_delay) != target)
  		    {
  		      mark_target_live_regs
  			(next_active_insn (JUMP_LABEL (trial_delay)),
--- 3052,3060 ----
  		{
  		  if (target == 0)
  		    break;
! 		  else if (JUMP_LABEL (trial_delay) == target)
! 		    target_uses--;
! 		  else
  		    {
  		      mark_target_live_regs
  			(next_active_insn (JUMP_LABEL (trial_delay)),
***************
*** 3073,3078 ****
--- 3087,3094 ----
  		    link_cc0_insns (trial);
  #endif
  
+ 		  if (passed_label)
+ 		    update_block (trial, trial);
  		  delete_insn (trial);
  		  if (slots_to_fill == ++slots_filled)
  		    break;
***************
*** 3398,3405 ****
  	      trial = try_split (pat, trial, 0);
  	      if (new_thread == old_trial)
  		new_thread = trial;
- 	      if (thread == old_trial)
- 		thread = trial;
  	      pat = PATTERN (trial);
  	      if ((thread_if_true
  		   ? eligible_for_annul_false (insn, *pslots_filled, trial, flags)
--- 3414,3419 ----
***************
*** 3663,3669 ****
        if (condition == 0)
  	continue;
  
!       /* Get the next active fallthrough and target insns and see if we own
  	 them.  Then see whether the branch is likely true.  We don't need
  	 to do a lot of this for unconditional branches.  */
  
--- 3677,3683 ----
        if (condition == 0)
  	continue;
  
!       /* Get the next active fallthough and target insns and see if we own
  	 them.  Then see whether the branch is likely true.  We don't need
  	 to do a lot of this for unconditional branches.  */
  
diff -rNci gcc-2.7.2/rtl.c gcc-2.7.2p/rtl.c
*** gcc-2.7.2/rtl.c	Thu Jun 15 12:02:59 1995
--- gcc-2.7.2p/rtl.c	Tue Jan 23 09:25:31 1996
***************
*** 174,184 ****
  			   "NOTE_INSN_PROLOGUE_END", "NOTE_INSN_EPILOGUE_BEG",
  			   "NOTE_INSN_DELETED_LABEL", "NOTE_INSN_FUNCTION_BEG"};
  
  char *reg_note_name[] = { "", "REG_DEAD", "REG_INC", "REG_EQUIV", "REG_WAS_0",
  			  "REG_EQUAL", "REG_RETVAL", "REG_LIBCALL",
  			  "REG_NONNEG", "REG_NO_CONFLICT", "REG_UNUSED",
  			  "REG_CC_SETTER", "REG_CC_USER", "REG_LABEL",
! 			  "REG_DEP_ANTI", "REG_DEP_OUTPUT" };
  
  /* Allocate an rtx vector of N elements.
     Store the length, and initialize all elements to zero.  */
--- 174,185 ----
  			   "NOTE_INSN_PROLOGUE_END", "NOTE_INSN_EPILOGUE_BEG",
  			   "NOTE_INSN_DELETED_LABEL", "NOTE_INSN_FUNCTION_BEG"};
  
+ /* intel1 added REG_DEP_TMP */
  char *reg_note_name[] = { "", "REG_DEAD", "REG_INC", "REG_EQUIV", "REG_WAS_0",
  			  "REG_EQUAL", "REG_RETVAL", "REG_LIBCALL",
  			  "REG_NONNEG", "REG_NO_CONFLICT", "REG_UNUSED",
  			  "REG_CC_SETTER", "REG_CC_USER", "REG_LABEL",
! 			  "REG_DEP_ANTI", "REG_DEP_OUTPUT", "REG_DEP_TMP"  };
  
  /* Allocate an rtx vector of N elements.
     Store the length, and initialize all elements to zero.  */
***************
*** 302,307 ****
--- 303,310 ----
    copy->volatil = orig->volatil;
    copy->unchanging = orig->unchanging;
    copy->integrated = orig->integrated;
+   /* intel1 */
+   copy->is_spill_rtx = orig->is_spill_rtx;
    
    format_ptr = GET_RTX_FORMAT (GET_CODE (copy));
  
diff -rNci gcc-2.7.2/rtl.def gcc-2.7.2p/rtl.def
*** gcc-2.7.2/rtl.def	Thu Jun 15 12:03:32 1995
--- gcc-2.7.2p/rtl.def	Tue Jan 23 09:25:31 1996
***************
*** 347,353 ****
     ---------------------------------------------------------------------- */
  
  /* An instruction that cannot jump.  */
! DEF_RTL_EXPR(INSN, "insn", "iuueiee", 'i')
  
  /* An instruction that can possibly jump.
     Fields ( rtx->fld[] ) have exact same meaning as INSN's.  */
--- 347,354 ----
     ---------------------------------------------------------------------- */
  
  /* An instruction that cannot jump.  */
! /* intel1 added last 0 - this field is used in scheduling */
! DEF_RTL_EXPR(INSN, "insn", "iuueiee0", 'i')
  
  /* An instruction that can possibly jump.
     Fields ( rtx->fld[] ) have exact same meaning as INSN's.  */
***************
*** 644,650 ****
  
  /* Operand:
       0:  value to be shifted.
!      1:  number of bits.  */
  DEF_RTL_EXPR(ASHIFT, "ashift", "ee", '2')
  DEF_RTL_EXPR(ROTATE, "rotate", "ee", '2')
  
--- 645,655 ----
  
  /* Operand:
       0:  value to be shifted.
!      1:  number of bits.  
!    ASHIFT and LSHIFT are distinguished because on some machines
!    these allow a negative operand and shift right in that case.
! */
! DEF_RTL_EXPR(LSHIFT, "lshift", "ee", '2')
  DEF_RTL_EXPR(ASHIFT, "ashift", "ee", '2')
  DEF_RTL_EXPR(ROTATE, "rotate", "ee", '2')
  
diff -rNci gcc-2.7.2/rtl.h gcc-2.7.2p/rtl.h
*** gcc-2.7.2/rtl.h	Thu Jun 15 12:03:16 1995
--- gcc-2.7.2p/rtl.h	Tue Jan 23 09:25:31 1996
***************
*** 140,145 ****
--- 140,148 ----
       In a REG, nonzero means this reg refers to the return value
       of the current function.  */
    unsigned integrated : 1;
+   /* intel1 Nonzero if this rtx is a spill rtx */
+   /* intel2 overlap: Nonzero if this rtx was created by memory_simplify */
+   unsigned is_spill_rtx: 1;
    /* The first element of the operands of this rtx.
       The number of operands and their types are controlled
       by the `code' field, according to rtl.def.  */
***************
*** 211,216 ****
--- 214,223 ----
  
  #define RTX_INTEGRATED_P(RTX) ((RTX)->integrated)
  #define RTX_UNCHANGING_P(RTX) ((RTX)->unchanging)
+ /* intel1 */
+ #define RTX_IS_SPILL_P(RTX) ((RTX)->is_spill_rtx)
+ /* intel2 - see a note above (for is_spill_rtx field) */
+ #define RTX_IS_RISC_P(RTX) ((RTX)->is_spill_rtx)
  
  /* RTL vector.  These appear inside RTX's when there is a need
     for a variable number of things.  The principle use is inside
***************
*** 259,264 ****
--- 266,276 ----
  #define PREV_INSN(INSN)	((INSN)->fld[1].rtx)
  #define NEXT_INSN(INSN)	((INSN)->fld[2].rtx)
  
+ /* intel1 used in sched*/
+ #define ORG_NEXT_INSN(INSN)	((INSN)->fld[7].rtx)
+ /* intel1 used in (loop) opt of spills */
+ #define SPILL_PSEUDO(INSN)	((INSN)->fld[7].rtint)
+ 
  /* The body of an insn.  */
  #define PATTERN(INSN)	((INSN)->fld[3].rtx)
  
***************
*** 348,354 ****
  		REG_EQUAL = 5, REG_RETVAL = 6, REG_LIBCALL = 7,
  		REG_NONNEG = 8, REG_NO_CONFLICT = 9, REG_UNUSED = 10,
  		REG_CC_SETTER = 11, REG_CC_USER = 12, REG_LABEL = 13,
! 		REG_DEP_ANTI = 14, REG_DEP_OUTPUT = 15 };
  
  /* Define macros to extract and insert the reg-note kind in an EXPR_LIST.  */
  #define REG_NOTE_KIND(LINK) ((enum reg_note) GET_MODE (LINK))
--- 360,366 ----
  		REG_EQUAL = 5, REG_RETVAL = 6, REG_LIBCALL = 7,
  		REG_NONNEG = 8, REG_NO_CONFLICT = 9, REG_UNUSED = 10,
  		REG_CC_SETTER = 11, REG_CC_USER = 12, REG_LABEL = 13,
! 		REG_DEP_ANTI = 14, REG_DEP_OUTPUT = 15, REG_DEP_TMP = 16 };
  
  /* Define macros to extract and insert the reg-note kind in an EXPR_LIST.  */
  #define REG_NOTE_KIND(LINK) ((enum reg_note) GET_MODE (LINK))
diff -rNci gcc-2.7.2/rtlanal.c gcc-2.7.2p/rtlanal.c
*** gcc-2.7.2/rtlanal.c	Fri Oct  6 17:13:57 1995
--- gcc-2.7.2p/rtlanal.c	Thu Jun 15 12:03:58 1995
***************
*** 428,435 ****
  static rtx reg_set_reg;
  static int reg_set_flag;
  
! static void
! reg_set_p_1 (x, pat)
       rtx x;
  {
    /* We don't want to return 1 if X is a MEM that contains a register
--- 428,435 ----
  static rtx reg_set_reg;
  static int reg_set_flag;
  
! void
! reg_set_p_1 (x)
       rtx x;
  {
    /* We don't want to return 1 if X is a MEM that contains a register
***************
*** 905,911 ****
  		|| ((GET_CODE (reg_set_last_value) == REG
  		     || GET_CODE (reg_set_last_value) == SUBREG)
  		    && ! reg_set_between_p (reg_set_last_value,
! 					    insn, orig_insn)))
  	      return reg_set_last_value;
  	    else
  	      return 0;
--- 905,911 ----
  		|| ((GET_CODE (reg_set_last_value) == REG
  		     || GET_CODE (reg_set_last_value) == SUBREG)
  		    && ! reg_set_between_p (reg_set_last_value,
! 					    NEXT_INSN (insn), orig_insn)))
  	      return reg_set_last_value;
  	    else
  	      return 0;
diff -rNci gcc-2.7.2/scan-decls.c gcc-2.7.2p/scan-decls.c
*** gcc-2.7.2/scan-decls.c	Mon Jun 19 18:18:43 1995
--- gcc-2.7.2p/scan-decls.c	Thu Jun 15 12:04:57 1995
***************
*** 246,252 ****
  	  break;
  
  	 default:
! 	  prev_id_start = 0;
  	}
      }
  }
--- 246,252 ----
  	  break;
  
  	 default:
! 	  prev_id_start = NULL;
  	}
      }
  }
